var prop = new Vue({
  el: '#properties',
  data: function() {
    return {
      selected:[],
      name: '',
      prefix: '',
      description: '',
      style: '',
      shadow: '',
      onEditDescription: false,
    }
  },
  watch: {
    // whenever question changes, this function will run
    selected: function (newSelected, oldSelected) {
      this.updateProp()

      // ! Vue render rawHtml has problem
      $('#prop_description').html(this.description);
      if (this.onEditDescription){
        $('#prop_description').summernote('code', this.description);
      }
    }
  },
  methods: {
    updateProp() {
      console.log('updateProp')

      var names = []
      var descriptions = []
      var prefixes = []
      var styles = []
      var shadows = []

      this.selected.map(function(item){ 
        names.push(item["text"])

        data = item.data;
        if (!data){data = {}}

        if (data.description){
          descriptions.push(data.description) 
        }
        if (data.prefix) {
          prefixes.push(data.prefix)
        }
        if (data.style) {
          styles.push(data.style)
        }
        if (data.shadow) {
          shadows.push(data.shadow)
        }
      });

      var unique_name = names.filter((v, i, a) => a.indexOf(v) === i); 
      if (unique_name.length == 1 ){
        name = unique_name[0]
      }else{
        name = ""
      }
      
      var unique_description = descriptions.filter((v, i, a) => a.indexOf(v) === i); 
      console.log(unique_description)
      if (unique_description.length == 1 ){
        description = unique_description[0]
      }else{
        description = ""
      }
      var unique_prefix= prefixes.filter((v, i, a) => a.indexOf(v) === i); 
      if (unique_prefix.length == 1 ){
        prefix = unique_prefix[0]
        if (prefix == null || prefix == undefined ){prefix=""}
      }else{
        prefix = ""
      }

      var unique_style = styles.filter((v, i, a) => a.indexOf(v) === i); 
      if (unique_style.length == 1 ){
        style = unique_style[0]
        if (style == null){style=""}
      }else{
        style = ""
      }

      var unique_shadow = shadows.filter((v, i, a) => a.indexOf(v) === i); 
      if (unique_shadow.length == 1 ){
        shadow = unique_shadow[0]
        if (shadow == null){shadow=""}
      }else{
        shadow = ""
      }

      this.name = name
      this.description = description
      this.prefix = prefix
      this.style = style
      this.shadow = shadow
    },
    statusbarText() {
      status = ""
      if (this.selected.length == 0){
        status = "No Selection"
      }else{
        status = this.selected.length + " Selected"
      }
      return status;
    },
    prefixChange(e) {
      var group = this.selected[0]
      if (!group){return}
      var data = group.data
      if (!data){data = {}}

      if (e.key == 'Enter'){
        e.target.blur();

        data.prefix = this.prefix
        group.data = data
        
        sortByPrefix(group)

        storeTreeView("setPrefix")
        setStatusbar()
      } else if (e.which == 27){
        // escape key
        e.target.blur();
        this.prefix = data.prefix;
      }
    },
    descriptionText() {
      status = ""
      if (this.selected.length == 0){
        status = "No Selection"
      }else{
        status = this.selected.length + " Selected"
      }
      return status;
    },
    editDescription(){
      this.onEditDescription = true;
      $('#prop_description').summernote({
        focus: true,
        toolbar: [
          // [groupName, [list of button]]
          ['style', ['bold', 'italic', 'underline', 'clear']],
          ['fontsize', ['fontsize']],
          ['color', ['color']],
          ['para', ['ul', 'ol', 'paragraph']],
          ['height', ['height']],
          ['insert', ['picture', 'link']],
          ['misc', ['fullscreen']]
        ]
      });
    },
    cancelDescription() {
      this.onEditDescription = false
      $('#prop_description').summernote('destroy');
    },
    saveDescription() {
      this.onEditDescription = false
      var description = $('#prop_description').summernote('code');
      $('#prop_description').summernote('destroy');
    
      for (let i = 0; i < this.selected.length; i++) {
        const node = this.selected[i];
        const data = node.data;
        if (!data){data = {}}
        data.description = description
        node.data = data
      }

      sketchup.set_description(description, this.selected)
    },
    canEditPrefix(){
      return this.selected.length == 1 && this.selected[0].type != 'sketchup_item';
    }
  },
  computed:{
  },
  mounted: function() {
    // sketchup.properties_ready();
  },
})